OUTPUT_FORMAT("elf32-bigmips")
OUTPUT_ARCH(mips)

EXTERN(__init)
ENTRY(__init)

MEMORY
{
	ram (rwx) : ORIGIN = 0x80000000, LENGTH = 4M
	ram_load (rwx) : ORIGIN = 0x80000400, LENGTH = 4M
	rom (rx) : ORIGIN = 0x90000000, LENGTH = 4M
	rom_gfx (rx) : ORIGIN = 0x90100000, LENGTH = 1M
}

SECTIONS
{
	/*
	.models : {
		CMakeFiles/prog.elf.dir/models/torus.c.o(.data)
		CMakeFiles/prog.elf.dir/models/img.c.o(.data)
		CMakeFiles/prog.elf.dir/models/rbb.c.o(.data)
		CMakeFiles/prog.elf.dir/models/plane.c.o(.data)
	} AT> rom_gfx
*/
	.text : {
		FILL(0xaa)
		/*_gp = ALIGN(16);*/
		*(.initialization)
		*(.text) 
	} > ram_load


/*
	.rodata1 : {
		*(.rodata1)
	}

	.sdata2 : {
		*(.sdata2 .sdata2.* .gnu.linkonce.s2.*)
	}

	.sbss2 : {
		*(.sbss2 .sbss2.* .gnu.linkonce.sb2.*)
	}

	.jcr : {
		KEEP(*(.jcr))
	}

	.data.rel.ro : {
		*(.data.rel.ro.local* .gnu.linkonce.d.rel.ro.local.*)
		*(.data.rel.ro .data.rel.ro.* .gnu.linkonce.d.rel.ro.*)
	}
*/
	.rodata : {
		*(.rodata)
	} > ram_load

	.sdata : { 
		_gp = ALIGN(16);
		*(.sdata /*.sdata.* .gnu.linkonce.s.**/)
	} > ram_load

	__bss_start = .;
	.sbss : {
		/**(.dynsbss)*/
		*(.sbss /*.sbss.* .gnu.linkonce.sb.**/)
		/**(.scommon)*/
	} > ram_load

	.bss : {
		/**(.dynbss)*/
		*(.bss /*.bss.* .gnu.linkonce.b.**/)
		/**(COMMON)*/
	} > ram_load
	
	/*. = ALIGN(16);*/
	__bss_end = .;

	.data : {
		*(EXCLUDE_FILE(*CMakeFiles/prog.elf.dir/models/torus.c.o
			*CMakeFiles/prog.elf.dir/models/img.c.o
			*CMakeFiles/prog.elf.dir/models/rbb.c.o
			*CMakeFiles/prog.elf.dir/models/temple.c.o
			*CMakeFiles/prog.elf.dir/models/plane.c.o) .data)
	} > ram_load
	__data_end = .;
	ASSERT(. < 0x80100000, "oops! too much stuff!")
	
	. = 0x80100000;
	.models . + 0x00000000 : SUBALIGN(16) {
		CMakeFiles/prog.elf.dir/models/temple.c.o(.data)
		CMakeFiles/prog.elf.dir/models/img.c.o(.data)
		CMakeFiles/prog.elf.dir/models/plane.c.o(.data)
		CMakeFiles/prog.elf.dir/models/rbb.c.o(.data)
		CMakeFiles/prog.elf.dir/models/torus.c.o(.data)
	}
	ASSERT(. < 0x80800000, "ROM size has its limits!")

	__heap_start = 0x80300000 + 320*240*2;
	__heap_end = 0x80400000 - 8192;
}
