#ifndef VEC__H
#define VEC__H

#include <types.h>

typedef struct {
	uint32_t	num_el;
	uint32_t	max_el;
	size_t		el_size;
	size_t		alignment;
	void*		data_unaligned;
	void*		data;
	void*		end;
} Vec;

Vec* new_Vec( size_t el_size, size_t alignment );
void delete_Vec( Vec* self );
void init_Vec( Vec* self, size_t el_size, size_t alignment );
void destroy_Vec( Vec* self );
void resize_Vec( Vec* self, uint32_t newsize );
void pushBack_Vec( Vec* self, const void* element );
void* getElement_Vec( Vec* self, uint32_t i );
const void* getConstElement_Vec( const Vec* self, uint32_t i );
void* getTail_Vec( Vec* self );
uint32_t getLength_Vec( const Vec* self );
void reset_Vec( Vec* self );
#if 0
typedef struct {
	Vec	vec;	// a vector of Vec pointers
} VecIterator;

void init_VecIterator( VecIterator* self );
void destroy_VecIterator( VecIterator* self );
void* inc_VecIterator( VecIterator* self );
VecIterator* zip_VecIterator( const VecIterator* i0, const VecIterator* i1 );
#endif

#endif	/* VEC__H */
