#ifndef MATERIAL_H
#define MATERIAL_H

#include <math/vector.h>
#include "texture.h"

#define TEXTURE_ID_NONE	0xFFFF

typedef enum {
	TEXTUREMAPPING_CONST,
	TEXTUREMAPPING_ENV
} TextureMapping;

typedef struct {
	Vector4f	color;
	TextureMapping	tmapping;
	//Texture*	tex;
	uint16_t	tex_id;
} Material;

#define MATERIAL_INIT( col, tm, texture ) \
{ .color = col, .tmapping = tm, .tex_id = texture }

void clone_Material( Material const* self, Material* clone );
void setColor_Material( Material* material, float r, float g, float b, float a );
Vector4f* getColor_Material( Material* material );

#endif	/* MATERIAL_H */
