#ifndef MATRIX_H
#define MATRIX_H

//typedef float	Matrix[4][4];
typedef struct {
	float m[4][4];
} Matrix;

void identity_Matrix( Matrix* mtx );
void rotate_Matrix( Matrix* mtx, float a, float x, float y, float z );
void scale_Matrix( Matrix* mtx, float x, float y, float z );
void translate_Matrix( Matrix* mtx, float x, float y, float z );
void invert_Matrix( const Matrix* restrict mi, Matrix* restrict mtxout );
void multiply_Matrix( Matrix* out, Matrix* ma, Matrix* mb );
void perspective_Matrix( Matrix* mtx, float* perspNorm, float fovy,
	float aspect, float near, float far );
void orthographic_Matrix( Matrix* mtx, float left, float right, float bottom,
		float top, float near, float far );
void align_Matrix( Matrix* mtx, float angle, float x, float y, float z );

#define MATRIX_GET(mtx, col, row) ((mtx).m[(col)][(row)])

#endif

