#ifndef MESH_H
#define MESH_H

#include <myheader.h>
#include <containers/vec_.h>

typedef struct {
	Layer*		layers;
	uint16_t	num_layers;
	Material*	materials;
	Texture*	textures;
	float		opacity;
} Mesh;

/* interface */
void init_Mesh( Mesh* self, StaticMesh const* static_mesh );
void destroy_Mesh( Mesh* mesh );
void setOpacity_Mesh( Mesh* mesh, float opacity );
float getOpacity_Mesh( Mesh const* mesh );

#endif	/* MESH_H */

