#ifndef TNODE_H
#define TNODE_H

#include <math/matrix.h>
#include "node.h"
#include "coordsys.h"

typedef struct TNode {
	Node		node;
	Matrix		mtx;
	Matrix*		resultMtx;
	void		(*Process)(struct TNode*, void*);
	Coordsys	csys;
} TNode;

void tnodeConstruct(TNode* tnode, TNode* parent);
void tnodeDestroy(TNode* tnode);
Node* tnodeGetNode(TNode* tnode);
Matrix* tnodeGetMatrix(TNode* tnode);
Matrix* tnodeGetTransformedMatrix(const TNode* tnode);
void tnodeReset(TNode* tnode);
void tnodeProcess(TNode* tnode, Matrix* resultMtx);
void tnodeTransform(TNode* node, Matrix* mtx);
const Coordsys* tnodeGetCoordsys(const TNode* tnode);

#endif	/* TNODE_H */

