#ifndef SURFACE_H
#define SURFACE_H

#include <types.h>

typedef enum {
	PIXELFMT_RGBA_5551,
	PIXELFMT_16
} PixelFormat;

typedef struct {
	PixelFormat	pixfmt;
	void*		data;
	uint16_t	width;
	uint16_t	height;
} Surface;

void init_Surface( Surface* surface, PixelFormat pixfmt, void* data,
	uint16_t width, uint16_t height );
PixelFormat getPixelFormat_Surface( const Surface* surface );
void* getData_Surface( const Surface* surface );
uint16_t getWidth_Surface( const Surface* surface );
uint16_t getHeight_Surface( const Surface* surface );
uint32_t getPixelsNum_Surface( const Surface* surface );
uint32_t getSize_Surface( const Surface* surface );

#endif	/* SURFACE_H */

