#include <sys/region.h>
#include <actmgr/actmgr.h>

void init_ActMgr( ActMgr* actmgr ) {
	init_Vec( &actmgr->actions, sizeof(Action*), ALIGN_DEFAULT );
}

void addAction_ActMgr( ActMgr* actmgr, Action* action ) {
	Action** a = getElement_Vec( &actmgr->actions, 0 );
	uint32_t i = getLength_Vec( &actmgr->actions );

	while( i ) {
		--i;
		if( *a ) {
			++a;
		} else {
			*a = action;
			break;
		}
	}

	if( 0 == i ) {
		pushBack_Vec( &actmgr->actions, &action );
	}
}

void process_ActMgr( ActMgr* actmgr, const Time* time ) {
	static Time timeInf = ACTMGR_TIME_INFINITY;

	Action** action = getElement_Vec( &actmgr->actions, 0 );

	uint32_t i = getLength_Vec( &actmgr->actions );

	while( i-- ) {
		if( NULL != *action
		&& TIME_LESS != compare_Time( time, &(*action)->timeStart )
		) {
			Time time_from_start
				= calcDuration_Time( &(*action)->timeStart, time );

			if( TIME_EQUAL ==
				compare_Time(
					&(*action)->timeDuration,
					&timeInf
				)
			|| TIME_LESS ==
				compare_Time(
					&time_from_start,
					&(*action)->timeDuration)
			) {
				(*action)->f(
					&time_from_start,
					(*action)->arg
				);
			} else {
				detachAction_ActMgr( actmgr, (*action)->f );
			}
		}
		++action;
	}
}

void detachAction_ActMgr( ActMgr* actmgr, actionf function ) {
	Action** action = getElement_Vec( &actmgr->actions, 0 );

	uint32_t i = getLength_Vec( &actmgr->actions );

	while( i-- ) {
		if( function == (*action)->f ) {
			(*action)->f = NULL;
			break;
		}
		++action;
	}
}

