#include <string.h>
#include <node/camera.h>

void init_Camera( Camera* camera, CameraType type ) {
	camera->type = type;
}

void destroy_Camera( Camera* camera ) {
	if(camera) {}
}

void setPerspParams_Camera( Camera* camera, float fovy, float near, float far ) {
	camera->cam.persp.fovy = fovy;
	camera->cam.persp.near = near;
	camera->cam.persp.far = far;
}

inline float getPerspFOVY_Camera( const Camera* camera ) {
	return camera->cam.persp.fovy;
}

inline float getPerspNear_Camera( const Camera* camera ) {
	return camera->cam.persp.near;
}

inline float getPerspFar_Camera( const Camera* camera ) {
	return camera->cam.persp.far;
}


inline void setOrthoParams_Camera( Camera* camera, float left, float right,
	float bottom, float top, float near, float far ) {

	camera->cam.ortho.left = left;
	camera->cam.ortho.right = right;
	camera->cam.ortho.bottom = bottom;
	camera->cam.ortho.top = top;
	camera->cam.ortho.near = near;
	camera->cam.ortho.far = far;
}

inline float getOrthoLeft_Camera( const Camera* camera ) {
	return camera->cam.ortho.left;
}

inline float getOrthoRight_Camera( const Camera* camera ) {
	return camera->cam.ortho.right;
}

inline float getOrthoBottom_Camera( const Camera* camera ) {
	return camera->cam.ortho.bottom;
}

inline float getOrthoTop_Camera( const Camera* camera ) {
	return camera->cam.ortho.top;
}

inline float getOrthoNear_Camera( const Camera* camera ) {
	return camera->cam.ortho.bottom;
}

inline float getOrthoFar_Camera( const Camera* camera ) {
	return camera->cam.ortho.far;
}

