#include <string.h>
#include <node/xformer_funcs.h>

void processBillboard_Xformer( struct Xformer* billboard_xf, void* data ) {
	const Xformer* camera_xf = data;
	Vector3f cn = getCoordsys_Xformer( camera_xf )->n;

	Matrix align;
	align_Matrix( &align, 0.0f, -cn.x, -cn.y, -cn.z );

	Vector3f bbpos = getCoordsys_Xformer( (Xformer*)billboard_xf )->origin;
	Matrix* mtx = getResultMatrix_Xformer( (Xformer*)billboard_xf );
	translate_Matrix( mtx, bbpos.x, bbpos.y, bbpos.z );

	multiply_Matrix( mtx, &align, mtx );
}

void processCamera_Xformer( struct Xformer* camera_xf, void* data ) {
	if( data ) {}

	memcpy(
		getResultMatrix_Xformer( (Xformer*)camera_xf ),
		getMatrix_Xformer( (Xformer*)camera_xf ),
		sizeof(Matrix)
	);
	reset_Xformer( (Xformer*)camera_xf );
}

