#include <sys/surface.h>

void init_Surface( Surface* surface, PixelFormat pixfmt, void* data,
	uint16_t width, uint16_t height ) {

	surface->pixfmt = pixfmt;
	surface->data = data;
	surface->width = width;
	surface->height = height;
}

inline PixelFormat getPixelFormat_Surface( const Surface* surface ) {
	return surface->pixfmt;
}

inline void* getData_Surface( const Surface* surface ) {
	return surface->data;
}

inline uint16_t getWidth_Surface( const Surface* surface ) {
	return surface->width;
}

inline uint16_t getHeight_Surface( const Surface* surface ) {
	return surface->height;
}

inline uint32_t getPixelsNum_Surface( const Surface* surface ) {
	return surface->width*surface->height;
}

inline uint32_t getSize_Surface( const Surface* surface ) {
	switch( getPixelFormat_Surface( surface ) ) {
		case PIXELFMT_RGBA_5551:
		case PIXELFMT_16:
			return getPixelsNum_Surface( surface ) * 2;
		default:
			return 0;
	}
}

